Create an Order for an Account

Creating an order for your end customer. Each trading request must pass in the account_id in the URL.

  • Note that when submitting crypto orders, market, limit and stop_limit orders are supported while the supported time_in_force values are gtc, and ioc.
  • For equities and crypto we accept fractional orders as well with either notional or qty provided.
  • Note that submitting an options order is only available for partners who have been enabled for Options BETA.
  • In case of Fixed Income, only market and limit order types with day time_in_force are supported, and order replacement is not supported. Note that submitting Fixed Income orders is only available for partners who have been enabled for Fixed Income.
Path Params
uuid
required

Account identifier.

Body Params
string

Symbol or asset ID to identify the asset to trade. Required for all order classes except for mleg.

string
  • For equities, the number of shares to trade. Can be fractionable for only market and day order types.
  • Required for mleg order class, represents the number of units to trade of this strategy.
  • For Fixed Income securities, qty represents the order size in par value (face value). For example, to place an order for 1 bond with a face value of $1,000, provide a qty of 1000.
string

Dollar amount to trade. Cannot work with qty. Only market and limit orders supported with time_in_force = day; Only limit orders for extended hours.

string
enum

Represents what side of the transaction an order was on. Required for all order classes except for mleg.

string
enum
required

The order types supported by Alpaca vary based on the order's security type. The following provides a comprehensive breakdown of the supported order types for each category:

  • Equity trading: market, limit, stop, stop_limit, trailing_stop.
  • Options trading: market, limit.
  • Options Multileg trading: market, limit.
  • Crypto trading: market, limit, stop_limit.
Allowed:
string
enum
required

The Time-In-Force values supported by Alpaca vary based on the order's security type. Here is a breakdown of the supported TIFs for each specific security type:

  • Equity trading: day, gtc, opg, cls, ioc, fok.
  • Options trading: day.
  • Crypto trading: gtc, ioc.

Below are the descriptions of each TIF:

  • day: A day order is eligible for execution only on the day it is live. By default, the order is only valid during Regular Trading Hours (9:30am - 4:00pm ET). If unfilled after the closing auction, it is automatically canceled. If submitted after the close, it is queued and submitted the following trading day. However, if marked as eligible for extended hours, the order can also execute during supported extended hours.

  • gtc: The order is good until canceled. Non-marketable GTC limit orders are subject to price adjustments to offset corporate actions affecting the issue. We do not currently support Do Not Reduce (DNR) orders to opt out of such price adjustments.

  • opg: Use this TIF with a market/limit order type to submit “market on open” (MOO) and “limit on open” (LOO) orders. This order is eligible to execute only in the market opening auction. Any unfilled orders after the open will be cancelled. OPG orders submitted after 9:28am but before 7:00pm ET will be rejected. OPG orders submitted after 7:00pm will be queued and routed to the following day’s opening auction. On open/on close orders are routed to the primary exchange. Such orders do not necessarily execute exactly at 9:30am / 4:00pm ET but execute per the exchange’s auction rules.

  • cls: Use this TIF with a market/limit order type to submit “market on close” (MOC) and “limit on close” (LOC) orders. This order is eligible to execute only in the market closing auction. Any unfilled orders after the close will be cancelled. CLS orders submitted after 3:50pm but before 7:00pm ET will be rejected. CLS orders submitted after 7:00pm will be queued and routed to the following day’s closing auction. Only available with API v2.

  • ioc: An Immediate Or Cancel (IOC) order requires all or part of the order to be executed immediately. Any unfilled portion of the order is canceled. Only available with API v2. Most market makers who receive IOC orders will attempt to fill the order on a principal basis only, and cancel any unfilled balance. On occasion, this can result in the entire order being cancelled if the market maker does not have any existing inventory of the security in question.

  • fok: A Fill or Kill (FOK) order is only executed if the entire order quantity can be filled, otherwise the order is canceled. Only available with API v2.

Allowed:
string

Required if type is limit or stop_limit.

  • In case of mleg, the limit_price parameter is expressed with the following notation:
    • A positive value indicates a debit, representing a cost or payment to be made.
    • A negative value signifies a credit, reflecting an amount to be received.
  • In case of Fied Income, the price is expressed in percentage of par value (face value). Price is always clean price, meaning it does not include accrued interest.
string

Required if type is stop or stop_limit

string

If type is trailing_stop, then one of trail_price or trail_percent is required

string

If type is trailing_stop, then one of trail_price or trail_percent is required

boolean

Defaults to false. If true, order will be eligible to execute in premarket/afterhours. Only works with type limit and time_in_force = day.

string
length ≤ 128

A unique identifier for the order. Automatically generated if not sent. (<= 128 characters)

string
enum

The order classes supported by Alpaca vary based on the order's security type. The following provides a comprehensive breakdown of the supported order classes for each category:

  • Equity trading: simple (or ""), oco, oto, bracket.
  • Options trading:
    • simple (or "")
    • mleg (required for multi-leg complex option strategies)
  • Crypto trading: simple (or "").
Allowed:
legs
array of objects

list of order legs (<= 4)

legs
take_profit
object

Takes in a string/number value for limit_price

stop_loss
object

Takes in a string/number values for stop_price and limit_price

string

The commission you want to collect from the user.

string
deprecated

deprecated: Please use the commission_type = bps instead and set the desired bps value in the commission field. The percent commission you want to charge the end user on the order (expressed in bps). Alpaca will convert the order to a notional amount for purposes of calculating commission.

string
enum
Defaults to notional

An enum to select how to interpret the value provided in the commission field.

  • notional: Charge commission on a per order basis. (When the commission_type field is omitted from the order request, this is used as the default).

  • qty: Charge commission on a per qty/contract basis, pro rated.

  • bps: The percent commission you want to charge the end user on the order (expressed in bps). Alpaca will convert the order to a notional amount for purposes of calculating commission. Commission value in bps can have up to two decimal places.

Allowed:
string
string
string
string
string
enum

Represents the desired position strategy.

Allowed:
Responses

422

Some parameters are not valid

Language
Credentials
Basic
base64
:
URL
Response
Click Try It! to start a request and see the response here! Or choose an example:
application/json